# -*- encoding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################




from osv import osv, fields
import time
from datetime import datetime, date
import decimal_precision as dp
import openerp
from openerp.tools.translate import _

class account_voucher(osv.osv):
    _inherit = 'account.voucher'

    def _check_journal_vs_account_move(self, cr, uid, ids, context=None):
        for record in self.browse(cr, uid, ids, context=context):
            if record.move_id and record.move_id.line_id:
                for line in record.move_id.line_id:
                    if line.account_id.type == 'liquidity': 
                        return (record.journal_id.id==record.move_id.journal_id.id and \
                                (record.journal_id.default_debit_account_id.id == line.account_id.id or record.journal_id.default_credit_account_id.id == line.account_id.id))
        return True
    
    _constraints = [
        (_check_journal_vs_account_move, 'No puede tener una cuenta contable diferente a la que tiene en el Diario de Pago, por favor revise la información... Intente Cancelando el registro, y capturando uno nuevo', ['move_id']),
    ]

class account_move(osv.osv):
    _inherit = 'account.move'
        

    def button_validate(self, cr, uid, ids, context=None):
        for move in self.browse(cr, uid, ids):
            if move.journal_id.type == 'bank':
                x=0
                for line in move.line_id:
                    if line.account_id.type == 'liquidity' and \
                        line.account_id.id in (move.journal_id.default_debit_account_id.id, move.journal_id.default_credit_account_id.id):
                        x += 1
                if not x:
                     raise osv.except_osv(_('Error!'), _('No puede tener una Póliza con Diario de tipo Bancos o Cheques y que ninguna de sus partidas tengan la cuenta contable a la que tiene por defecto el Diario Contable.'))
        return super(account_move, self).button_validate(cr, uid, ids, context=context)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
